package com.github.zengfr.easymodbus4j.channel;

import com.google.common.collect.Maps;
import io.netty.channel.Channel;
import io.netty.channel.group.ChannelGroup;
import io.netty.channel.group.DefaultChannelGroup;
import io.netty.util.concurrent.EventExecutor;
import io.netty.util.concurrent.GlobalEventExecutor;

import java.util.Collection;
import java.util.Map;

public class ChannelManagerImpl implements ChannelManager {
    protected Map<String, Channel> channels = Maps.newConcurrentMap();

    protected ChannelGroup clientChannels = new DefaultChannelGroup(getClass().getSimpleName(), GlobalEventExecutor.INSTANCE);

    public String getKey(Channel channel) {
        return channel.remoteAddress().toString();
    }

    public void removeChannel(Channel channel) {
        this.channels.remove(getKey(channel));
        this.clientChannels.remove(channel);
    }

    public void addChannel(Channel channel) {
        this.channels.put(getKey(channel), channel);
        this.clientChannels.add(channel);
    }

    public Channel getChannel(String channelAddress) {
        return this.channels.get(channelAddress);
    }

    public void close() {
        this.clientChannels.close().awaitUninterruptibly();
    }

    public Collection<Channel> getChannels() {
        return this.channels.values();
    }
}
