package com.github.zengfr.easymodbus4j.channel;

import com.github.zengfr.easymodbus4j.ModbusConfs;
import com.github.zengfr.easymodbus4j.codec.ModbusPduReqCodec;
import com.github.zengfr.easymodbus4j.codec.ModbusPduRespCodec;
import com.github.zengfr.easymodbus4j.codec.rtu.ModbusRtuCodec2;
import com.github.zengfr.easymodbus4j.handler.ModbusChannelSyncHandler;
import com.github.zengfr.easymodbus4j.protocol.tcp.ModbusFrame;
import io.netty.channel.ChannelHandler.Sharable;
import io.netty.channel.ChannelPipeline;
import io.netty.channel.SimpleChannelInboundHandler;

@Sharable
public class ModbusRtuChannelInitializer extends ModbusChannelInitializer {
    public ModbusRtuChannelInitializer(Boolean isSlave, SimpleChannelInboundHandler<ModbusFrame> handler) {
        super(isSlave, handler);
    }

    protected void initPipelinePreProcessHandler(ChannelPipeline pipeline) {
        if (this.isSlave.booleanValue()) {
            pipeline.addLast("codec", new ModbusRtuCodec2(new ModbusPduReqCodec()));
        } else {
            pipeline.addLast("codec", new ModbusRtuCodec2(new ModbusPduRespCodec()));
        }
    }

    protected void initPipelinePostProcessHandler(ChannelPipeline pipeline) {
        if (!this.isSlave.booleanValue())
            pipeline.addLast("sync", new ModbusChannelSyncHandler(ModbusConfs.SYNC_TRYACQUIRE_TIMEOUT_Millis));
    }
}
