package com.github.zengfr.easymodbus4j.channel;

import com.github.zengfr.easymodbus4j.codec.ModbusPduCodec;
import com.github.zengfr.easymodbus4j.codec.ModbusPduReqCodec;
import com.github.zengfr.easymodbus4j.codec.ModbusPduRespCodec;
import com.github.zengfr.easymodbus4j.codec.tcp.ModbusTcpCodec;
import com.github.zengfr.easymodbus4j.codec.tcp.ModbusTcpLFBFrameDecoder;
import com.github.zengfr.easymodbus4j.protocol.tcp.ModbusFrame;
import io.netty.channel.ChannelHandler;
import io.netty.channel.ChannelHandler.Sharable;
import io.netty.channel.ChannelPipeline;
import io.netty.channel.SimpleChannelInboundHandler;

@Sharable
public class ModbusTcpChannelInitializer extends ModbusChannelInitializer {
    public ModbusTcpChannelInitializer(Boolean isSlave, SimpleChannelInboundHandler<ModbusFrame> handler) {
        super(isSlave, handler);
    }

    protected void initPipelinePreProcessHandler(ChannelPipeline pipeline) {
        pipeline.addLast("framer", new ModbusTcpLFBFrameDecoder(true));
        if (this.isSlave.booleanValue()) {
            pipeline.addLast("codec", new ModbusTcpCodec(new ModbusPduReqCodec()));
        } else {
            pipeline.addLast("codec", new ModbusTcpCodec(new ModbusPduRespCodec()));
        }
    }

    protected void initPipelinePostProcessHandler(ChannelPipeline pipeline) {
    }
}
