package com.github.zengfr.easymodbus4j.codec.m2m;

import com.github.zengfr.easymodbus4j.protocol.rtu.ModbusRtuFrame;
import com.github.zengfr.easymodbus4j.protocol.tcp.ModbusFrame;
import com.github.zengfr.easymodbus4j.protocol.tcp.ModbusHeader;

public class ModbusFrameConvertor {
    public static ModbusFrame rtu2Tcp(ModbusRtuFrame frame, int transactionId, int protocolIdentifier) {
        int pduLength = frame.getFunction().calculateLength();
        short unitId = frame.getUnitId();
        ModbusHeader header = new ModbusHeader(transactionId, protocolIdentifier, pduLength, unitId);
        ModbusFrame f = new ModbusFrame(header, frame.getFunction());
        return f;
    }

    public static ModbusRtuFrame tcp2Rtu(ModbusFrame frame) {
        short unitId = frame.getHeader().getUnitIdentifier();
        ModbusRtuFrame f = new ModbusRtuFrame(unitId, frame.getFunction());
        return f;
    }
}
