package com.github.zengfr.easymodbus4j.codec.m2m;

import com.github.zengfr.easymodbus4j.protocol.rtu.ModbusRtuFrame;
import com.github.zengfr.easymodbus4j.protocol.tcp.ModbusFrame;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.MessageToMessageCodec;

import java.util.List;

public class ModbusRtu2TcpCodec extends MessageToMessageCodec<ModbusRtuFrame, ModbusFrame> {
    protected void encode(ChannelHandlerContext ctx, ModbusFrame msg, List<Object> out) throws Exception {
        ModbusRtuFrame frame = ModbusFrameConvertor.tcp2Rtu(msg);
        out.add(frame);
    }

    protected void decode(ChannelHandlerContext ctx, ModbusRtuFrame msg, List<Object> out) throws Exception {
        int transactionId = -1;
        int protocolIdentifier = 0;
        ModbusFrame frame = ModbusFrameConvertor.rtu2Tcp(msg, transactionId, protocolIdentifier);
        out.add(frame);
    }
}
