package com.github.zengfr.easymodbus4j.common.util;

public class ParseStringUtil {
    public static Integer parseInt(String[] vs, int index, Integer def) {
        if (vs != null && vs.length > index && !vs[index].isEmpty())
            return Integer.valueOf(vs[index]);
        return def;
    }

    public static Short parseShort(String[] vs, int index, Short def) {
        if (vs != null && vs.length > index && !vs[index].isEmpty())
            return Short.valueOf(vs[index]);
        return def;
    }

    public static String parseString(String[] vs, int index, String def) {
        if (vs != null && vs.length > index && !vs[index].isEmpty())
            return vs[index];
        return def;
    }

    public static boolean[] parseBooleanArray(String[] v) {
        boolean[] values = new boolean[v.length];
        for (int i = 0; i < v.length; i++)
            values[i] = parseBoolean(v[i]).booleanValue();
        return values;
    }

    public static Boolean parseBoolean(String[] vs, int index, boolean def) {
        if (vs != null && vs.length > index)
            return parseBoolean(vs[index]);
        return Boolean.valueOf(def);
    }

    public static Boolean parseBoolean(String v) {
        return Boolean.valueOf((v != null && (Boolean.valueOf(v).booleanValue() || "T".contains(v) || "true".contains(v))));
    }
}
