package com.github.zengfr.easymodbus4j.common.util;

import io.netty.util.concurrent.DefaultThreadFactory;

import java.util.concurrent.*;

public class ScheduledUtil {
    private static final ScheduledExecutorService scheduledExecutorService;

    static {
        DefaultThreadFactory defaultThreadFactory = new DefaultThreadFactory("schedule");
        scheduledExecutorService = Executors.newScheduledThreadPool(Runtime.getRuntime().availableProcessors() * 2 - 1, defaultThreadFactory);
    }

    public static ScheduledFuture<?> schedule(Runnable runnable, long milliseconds) {
        return scheduledExecutorService.schedule(runnable, milliseconds, TimeUnit.MILLISECONDS);
    }

    public static ScheduledFuture<?> scheduleAtFixedRate(Runnable runnable, long milliseconds) {
        return scheduledExecutorService.scheduleAtFixedRate(runnable, milliseconds, milliseconds, TimeUnit.MILLISECONDS);
    }

    public static ScheduledFuture<?> scheduleWithFixedDelay(Runnable runnable, long milliseconds) {
        return scheduledExecutorService.scheduleWithFixedDelay(runnable, milliseconds, milliseconds, TimeUnit.MILLISECONDS);
    }
}
