package com.github.zengfr.easymodbus4j.func;

import com.github.zengfr.easymodbus4j.protocol.ModbusFunction;
import io.netty.buffer.ByteBuf;
import io.netty.buffer.Unpooled;

public abstract class AbstractFunction extends ModbusFunction {
    protected int address;

    protected int value;

    public AbstractFunction(short functionCode) {
        super(functionCode);
    }

    public AbstractFunction(short functionCode, int address, int quantity) {
        super(functionCode);
        this.address = address;
        this.value = quantity;
    }

    public int getAddress() {
        return this.address;
    }

    public int getValue() {
        return this.value;
    }

    public int calculateLength() {
        return 5;
    }

    public ByteBuf encode() {
        ByteBuf buf = Unpooled.buffer(calculateLength());
        buf.writeByte(getFunctionCode());
        buf.writeShort(this.address);
        buf.writeShort(this.value);
        return buf;
    }

    public void decode(ByteBuf data) {
        this.address = data.readUnsignedShort();
        this.value = data.readUnsignedShort();
    }
}
