package com.github.zengfr.easymodbus4j.func.request;

import com.github.zengfr.easymodbus4j.func.AbstractRequest;
import io.netty.buffer.ByteBuf;

public class WriteSingleCoilRequest extends AbstractRequest {
    private boolean state;

    public WriteSingleCoilRequest() {
        super((short) 5);
    }

    public WriteSingleCoilRequest(int outputAddress, boolean state) {
        super((short) 5, outputAddress, state ? 65280 : 0);
        this.state = state;
    }

    public int getOutputAddress() {
        return this.address;
    }

    public void decode(ByteBuf data) {
        super.decode(data);
        this.state = (this.value == 65280);
    }

    public boolean isState() {
        return this.state;
    }

    public String toString() {
        return "WriteSingleCoilRequest{outputAddress=" + this.address + ", state=" + this.state + '}';
    }
}
