package com.github.zengfr.easymodbus4j.handler;

import com.github.zengfr.easymodbus4j.logging.ChannelLogger;
import io.netty.channel.ChannelHandler.Sharable;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.ChannelPromise;
import io.netty.handler.logging.LogLevel;
import io.netty.handler.logging.LoggingHandler;

import java.net.SocketAddress;

@Sharable
public class ModbusLoggingHandler extends LoggingHandler {
    public void connect(ChannelHandlerContext ctx, SocketAddress remoteAddress, SocketAddress localAddress, ChannelPromise promise) throws Exception {
        super.connect(ctx, remoteAddress, localAddress, promise);
    }

    public ModbusLoggingHandler() {
    }

    public ModbusLoggingHandler(LogLevel logLevel) {
        super(logLevel);
    }

    public void channelRead(ChannelHandlerContext ctx, Object msg) throws Exception {
        ChannelLogger.putMDC(ctx.channel());
        super.channelRead(ctx, msg);
    }

    public void read(ChannelHandlerContext ctx) throws Exception {
        ChannelLogger.putMDC(ctx.channel());
        super.read(ctx);
    }

    public void write(ChannelHandlerContext ctx, Object msg, ChannelPromise promise) throws Exception {
        ChannelLogger.putMDC(ctx.channel());
        super.write(ctx, msg, promise);
    }

    public void channelRegistered(ChannelHandlerContext ctx) throws Exception {
        ChannelLogger.putMDC(ctx.channel());
        super.channelRegistered(ctx);
    }

    public void channelActive(ChannelHandlerContext ctx) throws Exception {
        ChannelLogger.putMDC(ctx.channel());
        super.channelActive(ctx);
    }
}
