package com.github.zengfr.easymodbus4j.logging;

import ch.qos.logback.classic.spi.ILoggingEvent;
import ch.qos.logback.core.AppenderBase;
import ch.qos.logback.core.encoder.LayoutWrappingEncoder;

import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.SocketException;
import java.util.Date;

public class UdpAppender extends AppenderBase<ILoggingEvent> {
    LayoutWrappingEncoder<ILoggingEvent> encoder;

    int port;

    String ip;

    DatagramSocket socket;

    public LayoutWrappingEncoder<ILoggingEvent> getEncoder() {
        return this.encoder;
    }

    public void setEncoder(LayoutWrappingEncoder<ILoggingEvent> encoder) {
        this.encoder = encoder;
    }

    public int getPort() {
        return this.port;
    }

    public void setPort(int port) {
        this.port = port;
    }

    public String getIp() {
        return this.ip;
    }

    public void setIp(String ip) {
        this.ip = ip;
    }

    public DatagramSocket getSocket() {
        return this.socket;
    }

    public void setSocket(DatagramSocket socket) {
        this.socket = socket;
    }

    public void start() {
        if (this.encoder == null) {
            addError("no layout of udp appender");
            return;
        }
        if (this.socket == null)
            try {
                this.socket = new DatagramSocket(1024 + (int) ((new Date()).getTime() / 1000L) % 64000);
            } catch (SocketException e) {
                e.printStackTrace();
            }
        super.start();
    }

    protected void append(ILoggingEvent event) {
        try {
            byte[] buf = this.encoder.getLayout().doLayout(event).trim().getBytes();
            if (buf.length < 6556) {
                InetAddress address = InetAddress.getByName(this.ip);
                DatagramPacket p = new DatagramPacket(buf, buf.length, address, this.port);
                this.socket.send(p);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void stop() {
        if (!this.socket.isClosed())
            this.socket.close();
        super.stop();
    }
}
