package com.github.zengfr.easymodbus4j.queue;

import java.util.concurrent.Delayed;
import java.util.concurrent.TimeUnit;

public class DelayedItem<T> implements Delayed {
    private final T item;

    private long timeout;

    public DelayedItem(T item, long delay) {
        this.item = item;
        this.timeout += System.nanoTime();
    }

    public T getItem() {
        return this.item;
    }

    public int compareTo(Delayed delayed) {
        if (delayed == this)
            return 0;
        DelayedItem<T> t = (DelayedItem<T>) delayed;
        long d = getDelay(TimeUnit.NANOSECONDS) - t.getDelay(TimeUnit.NANOSECONDS);
        return (d == 0L) ? 0 : ((d < 0L) ? -1 : 1);
    }

    public long getDelay(TimeUnit unit) {
        return unit.convert(this.timeout - System.nanoTime(), TimeUnit.NANOSECONDS);
    }
}
