package com.github.zengfr.easymodbus4j.registers;

public class RegisterAddress {
    private final int type;

    private final int offset;

    public RegisterAddress(int range, int offset) {
        this.type = range;
        this.offset = offset;
    }

    public RegisterAddress(int address) {
        if (address < 10000) {
            this.type = 1;
            this.offset = address - 1;
        } else if (address < 20000) {
            this.type = 2;
            this.offset = address - 10001;
        } else if (address < 40000) {
            this.type = 4;
            this.offset = address - 30001;
        } else {
            this.type = 3;
            this.offset = address - 40001;
        }
    }

    public int getType() {
        return this.type;
    }

    public int getOffset() {
        return this.offset;
    }
}
