package com.github.zengfr.easymodbus4j.relay;

import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelFuture;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.SimpleChannelInboundHandler;

public abstract class RelayChannelInboundHandler extends SimpleChannelInboundHandler<ByteBuf> {
    protected ChannelHandlerContext innerCtx;

    protected ChannelFuture connectFuture;

    protected int port = 9090;

    public RelayChannelInboundHandler(int port) {
        this.port = port;
    }

    protected void channelRead0(ChannelHandlerContext ctx, ByteBuf msg) throws Exception {
        if (this.connectFuture.isDone() &&
                this.innerCtx != null && this.innerCtx.channel().isActive())
            this.innerCtx.writeAndFlush(msg);
    }
}
