package com.github.zengfr.easymodbus4j.relay;

import io.netty.bootstrap.Bootstrap;
import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandler;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.EventLoopGroup;
import io.netty.channel.SimpleChannelInboundHandler;
import io.netty.channel.socket.nio.NioSocketChannel;

import java.net.InetSocketAddress;

public class RelayClientChannelInboundHandler extends RelayChannelInboundHandler {
    protected String host;

    public RelayClientChannelInboundHandler(String host, int port) {
        super(port);
        this.host = host;
    }

    public void channelActive(ChannelHandlerContext ctx) throws Exception {
        Bootstrap bootstrap = new Bootstrap();
        bootstrap.channel(NioSocketChannel.class).handler(new SimpleChannelInboundHandler<ByteBuf>() {
            protected void channelRead0(ChannelHandlerContext ctx, ByteBuf in) throws Exception {
                RelayClientChannelInboundHandler.this.innerCtx = ctx;
            }
        });
        bootstrap.group(ctx.channel().eventLoop());
        this.connectFuture = bootstrap.connect(new InetSocketAddress(this.host, this.port));
    }
}
