package com.github.zengfr.easymodbus4j.relay;

import io.netty.bootstrap.ServerBootstrap;
import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandler;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.EventLoopGroup;
import io.netty.channel.SimpleChannelInboundHandler;
import io.netty.channel.socket.nio.NioServerSocketChannel;

public class RelayServerChannelInboundHandler extends RelayChannelInboundHandler {
    public RelayServerChannelInboundHandler(int port) {
        super(port);
    }

    public void channelActive(ChannelHandlerContext ctx) throws Exception {
        ServerBootstrap bootstrap = new ServerBootstrap();
        bootstrap.channel(NioServerSocketChannel.class).handler(new SimpleChannelInboundHandler<ByteBuf>() {
            protected void channelRead0(ChannelHandlerContext ctx, ByteBuf in) throws Exception {
                RelayServerChannelInboundHandler.this.innerCtx = ctx;
            }
        });
        bootstrap.group(ctx.channel().eventLoop());
        this.connectFuture = bootstrap.bind(this.port);
    }
}
