package com.github.zengfr.easymodbus4j.sender;

import com.google.common.collect.Maps;
import io.netty.channel.Channel;

import java.util.Map;

public class ChannelSenderFactory {
    private static class ChannelSenderFactoryHolder {
        private static final ChannelSenderFactory INSTANCE = new ChannelSenderFactory();
    }

    public static ChannelSenderFactory getInstance() {
        return ChannelSenderFactoryHolder.INSTANCE;
    }

    private final Map<String, ChannelSender> channelSendersMap = Maps.newConcurrentMap();

    public ChannelSender get(Channel channel) {
        String key = channel.toString();
        if (!this.channelSendersMap.containsKey(key))
            this.channelSendersMap.put(key, new ChannelSender(channel));
        return this.channelSendersMap.get(key);
    }
}
