package com.github.zengfr.easymodbus4j.sender.util;

import com.github.zengfr.easymodbus4j.protocol.ModbusFunction;
import com.github.zengfr.easymodbus4j.sender.ChannelSender;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

public class ModbusChannelSenderUtil {
    protected static Class<ChannelSender> channelSenderClazz = ChannelSender.class;

    public static ModbusFunction sendSyncFunc(ChannelSender sender, String func, int address, int value) throws IllegalAccessException, IllegalArgumentException, InvocationTargetException, NoSuchMethodException, SecurityException {
        Method method = channelSenderClazz.getMethod(func, int.class, int.class);
        return (ModbusFunction) method.invoke(sender, new Object[]{Integer.valueOf(address), Integer.valueOf(value)});
    }

    public static ModbusFunction sendSyncFunc(ChannelSender sender, String func, int address, boolean value) throws IllegalAccessException, IllegalArgumentException, InvocationTargetException, NoSuchMethodException, SecurityException {
        Method method = channelSenderClazz.getMethod(func, int.class, boolean.class);
        return (ModbusFunction) method.invoke(sender, new Object[]{Integer.valueOf(address), Boolean.valueOf(value)});
    }

    public static ModbusFunction sendSyncFunc(ChannelSender sender, String func, int address, int[] values) throws IllegalAccessException, IllegalArgumentException, InvocationTargetException, NoSuchMethodException, SecurityException {
        Method method = channelSenderClazz.getMethod(func, int.class, int.class, int[].class);
        return (ModbusFunction) method.invoke(sender, new Object[]{Integer.valueOf(address), Integer.valueOf(values.length), values});
    }

    public static ModbusFunction sendSyncFunc(ChannelSender sender, String func, int address, boolean[] values) throws IllegalAccessException, IllegalArgumentException, InvocationTargetException, NoSuchMethodException, SecurityException {
        Method method = channelSenderClazz.getMethod(func, int.class, int.class, boolean[].class);
        return (ModbusFunction) method.invoke(sender, new Object[]{Integer.valueOf(address), Integer.valueOf(values.length), values});
    }

    public static int sendAsyncFunc(ChannelSender sender, String func, int address, int value) throws IllegalAccessException, IllegalArgumentException, InvocationTargetException, NoSuchMethodException, SecurityException {
        Method method = channelSenderClazz.getMethod(func, int.class, int.class);
        return ((Integer) method.invoke(sender, new Object[]{Integer.valueOf(address), Integer.valueOf(value)})).intValue();
    }

    public static int sendAsyncFunc(ChannelSender sender, String func, int address, boolean value) throws IllegalAccessException, IllegalArgumentException, InvocationTargetException, NoSuchMethodException, SecurityException {
        Method method = channelSenderClazz.getMethod(func, int.class, boolean.class);
        return ((Integer) method.invoke(sender, new Object[]{Integer.valueOf(address), Boolean.valueOf(value)})).intValue();
    }

    public static int sendAsyncFunc(ChannelSender sender, String func, int address, int[] values) throws IllegalAccessException, IllegalArgumentException, InvocationTargetException, NoSuchMethodException, SecurityException {
        Method method = channelSenderClazz.getMethod(func, int.class, int.class, int[].class);
        return ((Integer) method.invoke(sender, new Object[]{Integer.valueOf(address), Integer.valueOf(values.length), values})).intValue();
    }

    public static int sendAsyncFunc(ChannelSender sender, String func, int address, boolean[] values) throws IllegalAccessException, IllegalArgumentException, InvocationTargetException, NoSuchMethodException, SecurityException {
        Method method = channelSenderClazz.getMethod(func, int.class, int.class, boolean[].class);
        return ((Integer) method.invoke(sender, new Object[]{Integer.valueOf(address), Integer.valueOf(values.length), values})).intValue();
    }
}
