package com.github.zengfr.easymodbus4j.server;

import com.github.zengfr.easymodbus4j.channel.ModbusChannelInitializer;
import com.github.zengfr.easymodbus4j.handler.ModbusRequestHandler;
import com.github.zengfr.easymodbus4j.handler.ModbusResponseHandler;
import io.netty.channel.ChannelInitializer;
import io.netty.channel.socket.SocketChannel;
import io.netty.util.internal.logging.InternalLogger;
import io.netty.util.internal.logging.InternalLoggerFactory;

public class ModbusServerRtuFactory {
    private static class ModbusServerRtuFactoryHolder {
        private static final ModbusServerRtuFactory INSTANCE = new ModbusServerRtuFactory();
    }

    protected static final InternalLogger logger = InternalLoggerFactory.getInstance(ModbusServerRtuFactory.class);

    public static ModbusServerRtuFactory getInstance() {
        return ModbusServerRtuFactoryHolder.INSTANCE;
    }

    public ModbusServer4RtuSlave createServer4Slave(int port, ModbusRequestHandler handle) throws Exception {
        ModbusServer4RtuSlave modbusServer4Slave = new ModbusServer4RtuSlave(port);
        modbusServer4Slave.setup(handle);
        return modbusServer4Slave;
    }

    public ModbusServer4RtuSlave createServer4Slave(int port, ModbusChannelInitializer handle) throws Exception {
        ModbusServer4RtuSlave modbusServer4Slave = new ModbusServer4RtuSlave(port);
        modbusServer4Slave.setup(handle);
        return modbusServer4Slave;
    }

    public ModbusServer4RtuMaster createServer4Master(int port, ModbusResponseHandler handle) throws Exception {
        ModbusServer4RtuMaster modbusServer4Master = new ModbusServer4RtuMaster(port);
        modbusServer4Master.setup(handle);
        return modbusServer4Master;
    }

    public ModbusServer4RtuMaster createServer4Master(int port, ModbusChannelInitializer handle) throws Exception {
        ModbusServer4RtuMaster modbusServer4Master = new ModbusServer4RtuMaster(port);
        modbusServer4Master.setup(handle);
        return modbusServer4Master;
    }
}
