package com.github.zengfr.easymodbus4j.server;

import com.github.zengfr.easymodbus4j.channel.ModbusChannelInitializer;
import com.github.zengfr.easymodbus4j.handler.ModbusRequestHandler;
import com.github.zengfr.easymodbus4j.handler.ModbusResponseHandler;
import io.netty.channel.ChannelInitializer;
import io.netty.channel.socket.SocketChannel;
import io.netty.util.internal.logging.InternalLogger;
import io.netty.util.internal.logging.InternalLoggerFactory;

public class ModbusServerTcpFactory {
    private static class ModbusServerTcpFactoryHolder {
        private static final ModbusServerTcpFactory INSTANCE = new ModbusServerTcpFactory();
    }

    protected static final InternalLogger logger = InternalLoggerFactory.getInstance(ModbusServerTcpFactory.class);

    public static ModbusServerTcpFactory getInstance() {
        return ModbusServerTcpFactoryHolder.INSTANCE;
    }

    public ModbusServer4TcpSlave createServer4Slave(int port, ModbusRequestHandler handle) throws Exception {
        ModbusServer4TcpSlave modbusServer4Slave = new ModbusServer4TcpSlave(port);
        modbusServer4Slave.setup(handle);
        return modbusServer4Slave;
    }

    public ModbusServer4TcpSlave createServer4Slave(int port, ModbusChannelInitializer handle) throws Exception {
        ModbusServer4TcpSlave modbusServer4Slave = new ModbusServer4TcpSlave(port);
        modbusServer4Slave.setup(handle);
        return modbusServer4Slave;
    }

    public ModbusServer4TcpMaster createServer4Master(int port, ModbusResponseHandler handle) throws Exception {
        ModbusServer4TcpMaster modbusServer4Master = new ModbusServer4TcpMaster(port);
        modbusServer4Master.setup(handle);
        return modbusServer4Master;
    }

    public ModbusServer4TcpMaster createServer4Master(int port, ModbusChannelInitializer handle) throws Exception {
        ModbusServer4TcpMaster modbusServer4Master = new ModbusServer4TcpMaster(port);
        modbusServer4Master.setup(handle);
        return modbusServer4Master;
    }
}
