package com.github.zengfr.easymodbus4j.util;

import com.github.zengfr.easymodbus4j.common.util.ByteUtil;
import com.github.zengfr.easymodbus4j.protocol.ModbusFunction;
import io.netty.buffer.ByteBuf;

public class ModbusFunctionUtil {
    public static boolean isError(short functionCode) {
        return (functionCode - 128 >= 0);
    }

    public static byte[] getFunctionValues(ModbusFunction func) {
        if (func.toString().contains("Read"))
            return getReadReponseFunctionValues(func);
        return getWriteReponseFunctionValues(func);
    }

    protected static byte[] getReadReponseFunctionValues(ModbusFunction func) {
        ByteBuf data = func.encode();
        short funcCode = data.readUnsignedByte();
        short byteCount = data.readUnsignedByte();
        byte[] inputs = new byte[byteCount];
        if (data.readableBytes() > 0)
            data.readBytes(inputs);
        return inputs;
    }

    protected static byte[] getWriteReponseFunctionValues(ModbusFunction func) {
        ByteBuf data = func.encode();
        short funcCode = data.readUnsignedByte();
        int address = data.readUnsignedShort();
        int value = data.readUnsignedShort();
        return ByteUtil.toByteArrayInt(new int[]{value});
    }
}
