package com.github.zengfr.easymodbus4j.util;

import com.github.zengfr.easymodbus4j.protocol.tcp.ModbusFrame;
import io.netty.channel.Channel;

import java.util.concurrent.atomic.AtomicInteger;

public class ModbusTransactionIdUtil {
    private static final AtomicInteger lastTransactionId = new AtomicInteger();

    public static int calculateTransactionId() {
        if (lastTransactionId.get() >= 64300)
            lastTransactionId.set(0);
        return lastTransactionId.incrementAndGet();
    }

    public static int getTransactionId(ModbusFrame frame) {
        int transactionIdentifier = frame.getHeader().getTransactionIdentifier();
        return transactionIdentifier;
    }

    public static int getTransactionIdByLocal(Channel channel) {
        int transactionIdentifier = channel.localAddress().toString().hashCode();
        return transactionIdentifier;
    }

    public static int getTransactionIdByRemote(Channel channel) {
        int transactionIdentifier = channel.remoteAddress().toString().hashCode();
        return transactionIdentifier;
    }
}
