package tofly.modbus_gateway2;

import com.github.zengfr.easymodbus4j.server.ModbusServer4TcpMaster;
import io.netty.channel.Channel;
import org.springframework.context.ApplicationEventPublisher;
import tofly.modbus_gateway2.event.OfflineEvent;

import static tofly.modbus_gateway2.FirstFrameDecoder.ATTR_KEY_DEVICE_ID;

public class GwModbusServer4TcpMaster extends ModbusServer4TcpMaster {

    private ApplicationEventPublisher eventPublisher;

    public GwModbusServer4TcpMaster(int port, ApplicationEventPublisher eventPublisher) {
        super(port);
        this.eventPublisher = eventPublisher;
    }

    @Override
    public void removeChannel(Channel channel) {
        String deviceId = channel.attr(ATTR_KEY_DEVICE_ID).get();
        if (deviceId != null) {
            eventPublisher.publishEvent(new OfflineEvent(deviceId));
        }
        super.removeChannel(channel);
    }

//    @Override
//    public void addChannel(Channel channel) {
//        super.addChannel(channel);
//    }
}
