package tofly.modbus_gateway2;

import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.LengthFieldBasedFrameDecoder;
import io.netty.util.internal.logging.InternalLogger;
import io.netty.util.internal.logging.InternalLoggerFactory;

public class ModbusRtuLFBFrameDecoder extends LengthFieldBasedFrameDecoder {
    private static final InternalLogger logger = InternalLoggerFactory.getInstance(ModbusRtuLFBFrameDecoder.class);
    private boolean skipUnknowBytes;

    public ModbusRtuLFBFrameDecoder(boolean skipUnknowBytes) {
        super(260, 2, 1, 2, 0);
        this.skipUnknowBytes = skipUnknowBytes;
    }

    public ModbusRtuLFBFrameDecoder() {
        this(false);
    }

    protected Object decode(ChannelHandlerContext ctx, ByteBuf in) throws Exception {
        if (this.skipUnknowBytes) {
            boolean skip = false;
            int i = in.readableBytes();
            if (i < 8) {
                skip = true;
            }

            if (i > 260) {
                skip = true;
            }

            if (skip) {
                in.skipBytes(in.readableBytes());
                logger.trace(String.format("跳过%s字节;", i));
            }
        }

        Object decoded = super.decode(ctx, in);
        return decoded;
    }
}
