package tofly.modbus_gateway2.event;

import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.ApplicationListener;
import org.springframework.stereotype.Component;
import tofly.modbus_gateway2.service.MonitorService;

@Component
@AllArgsConstructor
@Slf4j
public class OnlineEventListener implements ApplicationListener<OnlineEvent> {

    private final MonitorService monitorService;

    @Override
    public void onApplicationEvent(OnlineEvent event) {
        String deviceId = event.getSource();
        log.info("设备上线：" + deviceId);
        monitorService.storeState(deviceId, 1);
    }
}
