package tofly.modbus_gateway2.task;

import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;
import tofly.modbus_gateway2.service.StoreService;

import java.util.concurrent.TimeUnit;

/***
 * 数据恢复任务
 */
@Slf4j
@Service
public class RestoreTask {

    @Autowired(required = false)
    private StoreService storeService;

    @Scheduled(fixedRate = 1, timeUnit = TimeUnit.MINUTES)
    public void restore() {
        log.info("/////////////////////////////////异常检测恢复开始//////////");
        if (storeService != null) {
            int x = storeService.checkAndRestore();
            if (x > 0) {
                log.info("异常检测恢复{}条", x);
            }
        }
        log.info("/////////////////////////////////异常检测恢复结束//////////");
    }

}
