package tofly.modbus_gateway2.task;

import com.github.zengfr.easymodbus4j.server.ModbusServer4TcpMaster;
import io.netty.channel.Channel;
import io.netty.util.Attribute;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.concurrent.TimeUnit;

import static tofly.modbus_gateway2.FirstFrameDecoder.ATTR_KEY_DEVICE_ID;

/***
 * 跟踪任务
 */
@Slf4j
@Service
@AllArgsConstructor
public class TraceTask {

    private final ModbusServer4TcpMaster modbusServer4TcpMaster;
    @Scheduled(fixedRate = 10, timeUnit = TimeUnit.SECONDS)
    public void trace() {
        log.info("/////////////////////////////////在线设备//////////");
        Collection<Channel> channels = modbusServer4TcpMaster.getChannels();
        for (Channel channel : channels) {
            if (channel == null || (!channel.isActive()) || !channel.isOpen() || !channel.isWritable()) {
                log.warn("异常连接:" + channel);
                continue;
            }
            Attribute<String> attrDeviceId = channel.attr(ATTR_KEY_DEVICE_ID);
            String deviceId = attrDeviceId.get();
            if (deviceId != null) {
                log.info(deviceId);
            }
        }
    }

}
