package tofly.modbus_gateway2.util;

import tofly.modbus_gateway2.DataType;

import java.util.Arrays;

import static tofly.modbus_gateway2.DataType.*;
import static tofly.modbus_gateway2.DataType.DOUBLE_HGFEDCBA;

public class DataTypeUtil {
    private DataTypeUtil() {

    }

    public static int getByteLen(DataType type) {
        int byteLen = 0;
        if (Arrays.asList(SIGNED, SIGNED_AB, SIGNED_BA, UNSIGNED_AB, UNSIGNED_BA).contains(type)) {
            byteLen = 2;
        } else if (Arrays.asList(LONG_ABCD, LONG_CDAB, LONG_BADC, LONG_DCBA, FLOAT_ABCD, FLOAT_CDAB, FLOAT_BADC, FLOAT_DCBA).contains(type)) {
            byteLen = 4;
        } else if (Arrays.asList(DOUBLE_ABCDEFGH, DOUBLE_GHEFCDAB, DOUBLE_BADCFEHG, DOUBLE_HGFEDCBA).contains(type)) {
            byteLen = 8;
        }
        return byteLen;
    }


}
