package tofly.modbus_gateway2.util;

/**
 * 监测数据命名规范
 */
public class JsonItemConst {

    /**
     * 厂家设备原始的编号、ID、SN、地址(必要)
     */
    public static final String g_device_id = "device_id";

    /**
     * 同飞物联平台物模型关联唯一编号(必要)
     */
    public static final String g_tofly_device_id = "tofly_device_id";

    /**
     * 数据接收时间(必要)
     */
    public static final String g_collect_time = "collect_time";

    /**
     * 数据产生时间
     */
    public static final String g_generation_time = "generation_time";

    /**
     * 甲烷浓度，单位：百分比（%）
     */
    public static final String g_ch4_concentration = "ch4_concentration";

    /**
     * 湿度，单位：%rh
     */
    public static final String g_humidity = "humidity";

    /**
     * 压力，单位：兆帕（Mpa）
     */
    public static final String g_pressure = "pressure";

    /**
     * 信号强度，单位：毫瓦分贝（dBm）
     */
    public static final String g_signal_strength = "signal_strength";

    /**
     * 环境温度/温度，单位：摄氏度（℃）
     */
    public static final String g_ambient_temperature = "ambient_temperature";

    /**
     * 电池电压，单位：伏特（V）
     */
    public static final String g_battery_voltage = "battery_voltage";

    /**
     * 空高，单位：米（m）
     */
    public static final String g_ullage = "ullage";

    /**
     * 累计流量，单位：立方米(m³)
     */
    public static final String g_cum_flows = "cum_flows";

    /**
     * 累计流量次数
     */
    public static final String g_cum_flows_num = "cum_flows_num";

    /**
     * 横滚角，单位：度
     */
    public static final String g_roll_angle = "roll_angle";

    /**
     * 俯仰角，单位：度
     */
    public static final String g_angle_of_pitch = "angle_of_pitch";

    /**
     * 瞬时流量，单位：立方米/小时(m³/h)
     */
    public static final String g_instantaneous_flow = "instantaneous_flow";

    /**
     * 瞬时流量（水文，单位：立方米/秒，m³/s）
     */
    public static final String g_flow_rate = "flow_rate";

    /**
     * 水位，单位：米（m）
     */
    public static final String g_water_levels = "water_levels";

    /**
     * 频率，单位：赫兹（Hz）
     */
    public static final String g_frequency = "frequency";

    /**
     * 表面流速，单位：米/秒（m/s）
     */
    public static final String g_surface_velocity = "surface_velocity";

    /**
     * 瞬时流速，单位：米/秒（m/s）
     */
    public static final String g_instantaneous_velocity = "instantaneous_velocity";

    /**
     * 断面流速，单位：米/秒（m/s）
     */
    public static final String g_cross_section_velocity = "cross_section_velocity";

    /**
     * 过水面积，单位：平方米（㎡）
     */
    public static final String g_cross_section_area = "cross_section_area";

    /**
     * 电池电量，单位：毫安时（mAh）
     */
    public static final String g_battery_level = "battery_level";

    /**
     * 电流，单位：安（A）
     */
    public static final String g_current = "current";

    /**
     * 电压，单位：伏特（V）
     */
    public static final String g_voltage = "voltage";

    /**
     * 功率，单位：瓦特（W）
     */
    public static final String g_power = "power";

    /**
     * 浊度，单位：NTU
     */
    public static final String g_turbidity = "turbidity";

    /**
     * 液位，单位：米（m）
     */
    public static final String g_liquid_level = "liquid_level";

    /**
     * 余氯，单位：毫克每升（mg/L）
     */
    public static final String g_residual_chlorine = "residual_chlorine";

    /**
     * PH值
     */
    public static final String g_ph_value = "ph_value";

    /**
     * 阀门开度，单位：百分比（%）
     */
    public static final String g_opening_of_valve = "opening_of_valve";

    /**
     * 积水深度，单位：米（m）
     */
    public static final String g_ponding_depth = "ponding_depth";

    /**
     * 水深，单位：米（m）
     */
    public static final String g_depth_of_water = "depth_of_water";

    /**
     * 材质温度，单位：摄氏度（℃）
     */
    public static final String g_material_temperature = "material_temperature";

    /**
     * 冻结累计流量，单位：立方米(m³)
     */
    public static final String g_fre_cum_flows = "fre_cum_flows";
    /**
     * 冻结累计逆流量，单位：立方米(m³)
     */
    public static final String g_fre_cum_neg_flows = "fre_cum_neg_flows";

    /**
     * 冻结累计正流量，单位：立方米(m³)
     */
    public static final String g_fre_cum_pos_flows = "fre_cum_pos_flows";

    /**
     * 本周期累计流量，单位：立方米(m³)
     */
    public static final String g_cyc_cum_flows = "cyc_cum_flows";

    /**
     * 本周期累计逆流量，单位：立方米(m³)
     */
    public static final String g_cyc_cum_neg_flows = "cyc_cum_neg_flows";

    /**
     * 本周期累计正流量，单位：立方米(m³)
     */
    public static final String g_cyc_cum_pos_flows = "cyc_cum_pos_flows";

    /**
     * CCID号
     */
    public static final String g_ccid = "ccid";

    /**
     * IMEI号
     */
    public static final String g_imei = "imei";

    /**
     * 程序版本号
     */
    public static final String g_program_version = "program_version";

    /**
     * 硬件版本号
     */
    public static final String g_device_version = "device_version";

    /**
     * 逆向累计流量，单位：立方米(m³)
     */
    public static final String g_cum_neg_flows = "cum_neg_flows";

    /**
     * 正向累计流，单位：立方米(m³)
     */
    public static final String g_cum_pos_flows = "cum_pos_flows";

    /**
     * 逆向累计流量次数
     */
    public static final String g_cum_neg_flows_num = "cum_neg_flows_num";

    /**
     * 正向累计流次数
     */
    public static final String g_cum_pos_flows_num = "cum_pos_flows_num";

    /**
     * 信号质量
     */
    public static final String g_signal_quality = "signal_quality";

    /**
     * 信噪比
     */
    public static final String g_signal_noise_ratio = "signal_noise_ratio";

    /**
     * 覆盖等级
     */
    public static final String g_coverage_level = "coverage_level";

    /**
     * 地址
     */
    public static final String g_address = "address";

    /**
     * 时钟
     */
    public static final String g_clock = "clock";

    /**
     * 终端序列号
     */
    public static final String g_terminal_number = "terminal_number";

    /**
     * 1分钟雨量，单位：毫米（mm）
     */
    public static final String g_rainfall_minute_01 = "rainfall_minute_01";
    /**
     * 5分钟雨量，单位：毫米（mm）
     */
    public static final String g_rainfall_minute_05 = "rainfall_minute_05";
    /**
     * 10分钟雨量，单位：毫米（mm）
     */
    public static final String g_rainfall_minute_10 = "rainfall_minute_10";
    /**
     * 30分钟雨量，单位：毫米（mm）
     */
    public static final String g_rainfall_minute_30 = "rainfall_minute_30";
    /**
     * 1小时雨量，单位：毫米（mm）
     */
    public static final String g_rainfall_hour_01 = "rainfall_hour_01";
    /**
     * 2小时雨量，单位：毫米（mm）
     */
    public static final String g_rainfall_hour_02 = "rainfall_hour_02";
    /**
     * 3小时雨量，单位：毫米（mm）
     */
    public static final String g_rainfall_hour_03 = "rainfall_hour_03";
    /**
     * 6小时雨量，单位：毫米（mm）
     */
    public static final String g_rainfall_hour_06 = "rainfall_hour_06";
    /**
     * 12小时雨量，单位：毫米（mm）
     */
    public static final String g_rainfall_hour_12 = "rainfall_hour_12";
    /**
     * 水温，单位：摄氏度（℃）
     */
    public static final String g_water_temperature = "water_temperature";
    /**
     * 溶解氧，单位：毫克每升（mg/L）
     */
    public static final String g_dissolved_oxygen = "dissolved_oxygen";
    /**
     * 电导率，单位：微西门/cm（μS/cm）
     */
    public static final String g_electric_conductivity = "electric_conductivity";
    /**
     * 高锰酸盐指数，单位：毫克每升（mg/L）
     */
    public static final String g_permanganate_index = "permanganate_index";
    /**
     * 氨氮，单位：毫克每升（mg/L）
     */
    public static final String g_ammonia_nitrogen = "ammonia_nitrogen";
    /**
     * 总磷，单位：毫克每升（mg/L）
     */
    public static final String g_total_phosphorus = "total_phosphorus";
    /**
     * 总氮，单位：毫克每升（mg/L）
     */
    public static final String g_total_nitrogen = "total_nitrogen";
    /**
     * 叶绿素a，单位：微克每升(μg/L)
     */
    public static final String g_chlorophyll_a = "chlorophyll_a";
    /**
     * 闸门开度，单位：米（m）
     */
    public static final String g_gatage = "gatage";

    /**
     * 设备型号
     */
    public static final String g_device_model = "device_model";
    /**
     * 最高水位，单位：米（m）
     */
    public static final String g_highest_water_levels = "highest_water_levels";
    /**
     * 最低水位，单位：米（m）
     */
    public static final String g_lowest_water_levels = "lowest_water_levels";
    /**
     * 最高水位对应的时间
     */
    public static final String g_highest_water_levels_time = "highest_water_levels_time";
    /**
     * 最低水位对应的时间
     */
    public static final String g_lowest_water_levels_time = "lowest_water_levels_time";
    /**
     * 每小时降雨量，单位：毫米（mm）
     */
    public static final String g_hourly_rainfall = "hourly_rainfall";
    /**
     * 暴雨加报降雨量，单位：毫米（mm）
     */
    public static final String g_rainstorm_rainfall = "rainstorm_rainfall";
    /**
     * 累计雨量，单位：毫米（mm）
     */
    public static final String g_cum_rainfall = "cum_rainfall";

    /**
     * 日最高流量，单位：立方米/小时(m³/h)
     */
    public static final String g_day_max_Flows = "day_max_flows";

    /**
     * 日最高流量时间
     */
    public static final String g_day_max_flows_time = "day_max_flows_time";


    /**
     * 30分钟间隔流量，单位：立方米(m³)
     */
    public static final String g_flows_minute_30 = "flows_minute_30";

    /**
     * 30分钟瞬时流量，单位：立方米/小时(m³/h)
     */
    public static final String g_instantaneous_flow_minute_30 = "flows_instantaneous_flow_minute_30";

    /**
     * 5分钟正累计流量，单位：升(L)
     */
    public static final String g_cum_pos_flows_minute_5= "cum_pos_flows_minute_5";

    /**
     * 5分钟负累计流量，单位：升(L)
     */
    public static final String g_cum_neg_flows_minute_5= "cum_neg_flows_minute_5";

    /**
     * 5分钟瞬时流量，单位：立方米/小时(m³/h)
     */
    public static final String g_instantaneous_flow_minute_5 = "flows_instantaneous_flow_minute_5";

    /**
     * 管网压力，单位：兆帕(Mpa)
     */
    public static final String g_pipe_pressure = "pipe_pressure";

    /**
     * 用水状态
     */
    public static final String g_water_condition = "water_condition";

    /**
     * 脉冲个数
     */
    public static final String g_pulse_num = "pulse_num";

    /**
     * 设备实时电压，单位：伏特（V）
     */
    public static final String g_real_time_voltage = "real_time_voltage";
}
