package tofly.modbus_gateway2.util;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;

/**
 * JSON工具
 */
public class JsonUtil {

    private static ObjectMapper mapper = new ObjectMapper();

    /**
     *  对象转JSON字符串
     * @param object 对象
     * @return
     */
    public static String toString(Object object){
        try {
            return mapper.writeValueAsString(object);
        } catch (JsonProcessingException e) {
            throw new RuntimeException(e);
        }
    }

    /**
     *  JSON字符串转对象
     * @param p_sJSON JSON字符串
     * @param p_clsObject 对象类
     * @return
     */
    public static Object toBean(String p_sJSON, Class<?> p_clsObject){
        try {
            return mapper.readValue(p_sJSON, p_clsObject);
        } catch (JsonProcessingException e) {
            throw new RuntimeException(e);
        }
    }

    /**
     * JSON字符串转对象
     * @param p_sJSON JSON字符串
     * @return
     */
    public static JsonNode toJsonNode(String p_sJSON) throws JsonProcessingException {
        return mapper.readTree(p_sJSON);
    }

}
